#!/usr/bin/env ruby
require 'optparse'
req = ''
opts = OptionParser.new
opts.on("-r LIB"){|lib| req << '-r ' + lib + ' '}
opts.parse!(ARGV)
klass = ARGV[0]
vers = ('1.8.0'..'1.8.6').to_a + ['1.9.0']

s_mthds = proc{|v, klass|
  `ruby-#{v} #{req} -e 'print (#{klass}.public_methods - (#{klass}.class == Class ? #{klass}.superclass.public_methods - ["new"] : Object.public_methods)).join("\n")'`.split
}

i_mthds = proc{|v, klass|
  `ruby-#{v} #{req} -e 'print #{klass}.instance_methods(false).join("\n")'`.split
}

konstants = proc{|v, klass|
  `ruby-#{v} #{req} -e 'print (#{klass}.constants).join("\n")'`.split
}

[['.', s_mthds], ['#', i_mthds], ['::', konstants]].each{|mid, pr|
  max = 30
  all_mthds = {}
  tmp_mthds = {}
  vers.each{|v|
    tmp = pr.call(v, klass)
    tmp_mthds[v] = Hash.new('-')
    tmp.each{|m|
      all_mthds[m] = true
      tmp_mthds[v][m] = 'o'
    }
  }
  
  next if all_mthds.empty?

  sz = all_mthds.keys.map{|s| s.size}.max + klass.size + mid.size
  max = max > sz ? max : sz
  puts (" " * (max+1)) + vers.map{|s| s.gsub(/[\. ]/, '')}.join(' ')  
  all_mthds.sort.each{|m, |
    s =  "#{klass}#{mid}#{m}"
    print s
    print " " * (max - s.size).abs
    vers.each{|v|
      print "%4s" % tmp_mthds[v][m]
    }
    puts
  }
  puts '-' * 80
}
